package test;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import sample.vo.DeptVO;
import sample.vo.EmpVO;

import com.poscoict.glueframework.context.GlueStaticContext;
import com.poscoict.glueframework.dao.GlueGenericDao;
import com.poscoict.glueframework.dao.vo.GlueParameter;

public class MyBatisDaoTest
{
    /**
     * @param args
     */
    public static void main( String[] args )
    {
        GlueGenericDao dao = (GlueGenericDao) GlueStaticContext.getBeanFactory().getBeanObject( "test-dao" );
                
        List<EmpVO> rowSet = null;        
        int cnt = 0;

        // emp.xml
        GlueParameter<String> param1 = new GlueParameter<String>();
        param1.setParameter( "10" );
        rowSet = dao.find( "emp.mapper.getEmp", param1 );
        System.out.println( rowSet.size() );
        
        // vo  parameter  ؼ parametertype=map  ޴° , ݴ ȵ.
        DeptVO dept = new DeptVO();
        dept.setDeptno( "10" );
        rowSet = dao.find( "emp.mapper.getEmp", new GlueParameter<DeptVO>( dept ) );
        System.out.println( rowSet.size() );
        
        Map<String, Object> map = new HashMap<String, Object>();
        map.put( "deptno", "10" );
        rowSet = dao.find( "emp.mapper.getEmp2", new GlueParameter<Map<String, Object>>( map ) );
        System.out.println( rowSet.size() );
        
        map.put( "deptno", "10" );
        map.put( "sal", "10" );
        rowSet = dao.find( "emp.mapper.getEmp3", new GlueParameter<Map<String, Object>>( map ) );
        System.out.println( rowSet.size() );
                
        map.put( "empno", (long)9999 );
        map.put( "ename", "KAL" );
        map.put( "sal", (long) 123456 );
        
        cnt = dao.delete( "emp.mapper.insertEmp", new GlueParameter<Map<String, Object>>( map ) );
        System.out.println("insert cnt : " + cnt);

        EmpVO emp = new EmpVO();
        emp.setEmpno( (long) 9999 );
        emp.setEname( "JIN" );
        emp.setDeptno( (long) 10 );
        emp.setSal( (long) 100 );
        cnt = dao.update( "emp.mapper.updateEmp", new GlueParameter<EmpVO>( emp ) );
        System.out.println("update cnt : " + cnt);        
        
        cnt = dao.delete( "emp.mapper.deleteEmp", new GlueParameter<Map<String, Object>>( map ) );
        System.out.println("delete cnt : " + cnt);
        
        
        
        // emp2.xml 
        rowSet = dao.find( "emp.custom.mapper.getEmp", new GlueParameter<EmpVO>(emp));
        System.out.println( rowSet.size() );
        
        // vo  parameter  ؼ parametertype=map  ޴° 
        rowSet = dao.find( "emp.custom.mapper.getEmp2", new GlueParameter<EmpVO>(emp));
        System.out.println( rowSet.size() );
        
        rowSet = dao.find( "emp.custom.mapper.getEmp3", new GlueParameter<EmpVO>( emp ) );
        System.out.println( rowSet.size() );        
        
        emp.setEname( "KAL" );
        emp.setSal( (long)123456 );
        dao.update( "emp.custom.mapper.insertEmp", new GlueParameter<EmpVO>( emp ) );
        System.out.println("insert cnt : " + cnt);
        emp.setSal( (long) 100 );
        dao.update( "emp.custom.mapper.updateEmp", new GlueParameter<EmpVO>( emp ) );
        System.out.println("update cnt : " + cnt);
        cnt = dao.delete( "emp.custom.mapper.deleteEmp", new GlueParameter<EmpVO>( emp ) );
        System.out.println("delete cnt : " + cnt);



        // insert into EMP(EMPNO, ENAME, SAL, DEPTNO)
        // values(#{empno}, #{ename}, #{sal}, #{deptno})
    }
}